//+------------------------------------------------------------------+
//|                                                AmmarDataInfo.mq4 |
//|                                                     Ammar  2004 |
//|                                             Mail: ammar@mpsb.com |
//+------------------------------------------------------------------+
#property copyright "Ammar PSB  2014"
#property link      "Mail: "www.mql5.com/en/users/aces70""
#property version   "VRev1.1"
#property strict

#property indicator_chart_window

extern bool SendEmail=true;
extern bool AlertOnAllTFSignalSinc=false;
extern bool AlertR3=true;
extern bool AlertS3=true;
extern bool SaveScreenshot=true;
extern string ScreenshotPrefix="Ammar Data info";
extern string MinCount="Fill Number of Min Count from max of 42";
extern int MinRedCount=33;
extern int MinLimeCount=33;

int M1RedCounter,M1TomatoCounter,M1LimeCounter,M1YellowGreenCounter,M5RedCounter,M5TomatoCounter,M5LimeCounter,M5YellowGreenCounter,M15RedCounter,M15TomatoCounter,M15LimeCounter,M15YellowGreenCounter;
int M30RedCounter,M30LimeCounter,H1RedCounter,H1LimeCounter,H2RedCounter,H2LimeCounter;
double PrevBid;

datetime ALLBARLastAlertTime=0;
datetime S3LastAlertTime=0;
datetime R3LastAlertTime=0;

int init() {
   return (0);
}

int deinit() {
   ObjectDelete("PIVOT");
   ObjectDelete("Support 1");
   ObjectDelete("P-S1");
   ObjectDelete("Support 2");
   ObjectDelete("S1-S2");
   ObjectDelete("Support 3");
   ObjectDelete("S2-S3");
   ObjectDelete("Pivot level");
   ObjectDelete("Resistance 1");
   ObjectDelete("P-R1");
   ObjectDelete("Resistance 2");
   ObjectDelete("R1-R2");
   ObjectDelete("Resistance 3");
   ObjectDelete("R2-R3");
   ObjectDelete("S1");
   ObjectDelete("S01");
   ObjectDelete("S2");
   ObjectDelete("S12");
   ObjectDelete("S3");
   ObjectDelete("S23");
   ObjectDelete("R1");
   ObjectDelete("R01");
   ObjectDelete("R2");
   ObjectDelete("R12");
   ObjectDelete("R3");
   ObjectDelete("R23");
   ObjectDelete("PIVOT");
   ObjectDelete("DML");
   ObjectDelete("DML1");
   ObjectDelete("DML5");
   ObjectDelete("DML15");
   ObjectDelete("DML1M0");
   ObjectDelete("DML1M9");
   ObjectDelete("DML1M8");
   ObjectDelete("DML1M7");
   ObjectDelete("DML1M6");
   ObjectDelete("DML1M5");
   ObjectDelete("DML1M4");
   ObjectDelete("DML1M3");
   ObjectDelete("DML1M2");
   ObjectDelete("DML1M1");
   ObjectDelete("DML5M0");
   ObjectDelete("DML5M9");
   ObjectDelete("DML5M8");
   ObjectDelete("DML5M7");
   ObjectDelete("DML5M6");
   ObjectDelete("DML5M5");
   ObjectDelete("DML5M4");
   ObjectDelete("DML5M3");
   ObjectDelete("DML5M2");
   ObjectDelete("DML5M1");
   ObjectDelete("DML15M0");
   ObjectDelete("DML15M9");
   ObjectDelete("DML15M8");
   ObjectDelete("DML15M7");
   ObjectDelete("DML15M6");
   ObjectDelete("DML15M5");
   ObjectDelete("DML15M4");
   ObjectDelete("DML15M3");
   ObjectDelete("DML15M2");
   ObjectDelete("DML15M1");
   ObjectDelete("DR3");
   ObjectDelete("DR23");
   ObjectDelete("DR2");
   ObjectDelete("DR12");
   ObjectDelete("DR1");
   ObjectDelete("DR01");
   ObjectDelete("DP");
   ObjectDelete("DLEVEL");
   ObjectDelete("DS3");
   ObjectDelete("DS23");
   ObjectDelete("DS2");
   ObjectDelete("DS12");
   ObjectDelete("DS1");
   ObjectDelete("DS01");
   ObjectDelete("DSMSG");
   ObjectDelete("D30D");
   ObjectDelete("D60D");
   ObjectDelete("D120D");
   ObjectDelete("D30M4");
   ObjectDelete("D30M3");
   ObjectDelete("D30M2");
   ObjectDelete("D30M1");
   ObjectDelete("D30P4");
   ObjectDelete("D30P3");
   ObjectDelete("D30P2");
   ObjectDelete("D30P1");
   ObjectDelete("D30N");
   ObjectDelete("D60M4");
   ObjectDelete("D60M3");
   ObjectDelete("D60M2");
   ObjectDelete("D60M1");
   ObjectDelete("D60P4");
   ObjectDelete("D60P3");
   ObjectDelete("D60P2");
   ObjectDelete("D60P1");
   ObjectDelete("D60N");
   ObjectDelete("D120M4");
   ObjectDelete("D120M3");
   ObjectDelete("D120M2");
   ObjectDelete("D120M1");
   ObjectDelete("D120P4");
   ObjectDelete("D120P3");
   ObjectDelete("D120P2");
   ObjectDelete("D120P1");
   ObjectDelete("D120N");
   PrevBid=Bid;
   return (0);
}

int start() {
   M1RedCounter=0;
   M1TomatoCounter=0;
   M1LimeCounter=0;
   M1YellowGreenCounter=0;
   M5RedCounter=0;
   M5TomatoCounter=0;
   M5LimeCounter=0;
   M5YellowGreenCounter=0;
   M15RedCounter=0;
   M15TomatoCounter=0;
   M15LimeCounter=0;
   M15YellowGreenCounter=0;
   M30RedCounter=0;
   M30LimeCounter=0;
   H1RedCounter=0;
   H1LimeCounter=0;
   H2RedCounter=0;
   H2LimeCounter=0;

   double ld_40;
   double lda_48[1][6];
   double ld_52;
   double ld_60;
   double ld_68;
   string ls_192;
   drawPSR("DML", "EMA SIGNAL", 10, Yellow, 15, 20);
   drawPSR("DML1", "  1mnt :", 9, White, 20, 40);
   drawPSR("DML5", "  5mnt :", 9, White, 20, 55);
   drawPSR("DML15", "15mnt :", 9, White, 20, 70);
   int li_4 = White;
   double l_ima_8 = iMA(NULL, PERIOD_M1, 25, 0, MODE_EMA, PRICE_CLOSE, 9);
   double l_ima_16 = iMA(NULL, PERIOD_M1, 50, 0, MODE_EMA, PRICE_CLOSE, 9);
   double l_ima_24 = iMA(NULL, PERIOD_M1, 5, 0, MODE_EMA, PRICE_CLOSE, 9);
   double l_ima_32 = iMA(NULL, PERIOD_M1, 10, 0, MODE_LWMA, PRICE_CLOSE, 9);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML1M9", "|||||", 9, li_4, 75, 40);
   if(li_4==Red) M1RedCounter++;
   if(li_4==Tomato) M1TomatoCounter++;
   if(li_4==Lime) M1LimeCounter++;
   if(li_4==YellowGreen) M1YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M1, 25, 0, MODE_EMA, PRICE_CLOSE, 8);
   l_ima_16 = iMA(NULL, PERIOD_M1, 50, 0, MODE_EMA, PRICE_CLOSE, 8);
   l_ima_24 = iMA(NULL, PERIOD_M1, 5, 0, MODE_EMA, PRICE_CLOSE, 8);
   l_ima_32 = iMA(NULL, PERIOD_M1, 10, 0, MODE_LWMA, PRICE_CLOSE, 8);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML1M8", "|||||", 9, li_4, 90, 40);
   if(li_4==Red) M1RedCounter++;
   if(li_4==Tomato) M1TomatoCounter++;
   if(li_4==Lime) M1LimeCounter++;
   if(li_4==YellowGreen) M1YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M1, 25, 0, MODE_EMA, PRICE_CLOSE, 7);
   l_ima_16 = iMA(NULL, PERIOD_M1, 50, 0, MODE_EMA, PRICE_CLOSE, 7);
   l_ima_24 = iMA(NULL, PERIOD_M1, 5, 0, MODE_EMA, PRICE_CLOSE, 7);
   l_ima_32 = iMA(NULL, PERIOD_M1, 10, 0, MODE_LWMA, PRICE_CLOSE, 7);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   if(li_4==Red) M1RedCounter++;
   if(li_4==Tomato) M1TomatoCounter++;
   if(li_4==Lime) M1LimeCounter++;
   if(li_4==YellowGreen) M1YellowGreenCounter++;

   drawPSR("DML1M7", "|||||", 9, li_4, 105, 40);
   l_ima_8 = iMA(NULL, PERIOD_M1, 25, 0, MODE_EMA, PRICE_CLOSE, 6);
   l_ima_16 = iMA(NULL, PERIOD_M1, 50, 0, MODE_EMA, PRICE_CLOSE, 6);
   l_ima_24 = iMA(NULL, PERIOD_M1, 5, 0, MODE_EMA, PRICE_CLOSE, 6);
   l_ima_32 = iMA(NULL, PERIOD_M1, 10, 0, MODE_LWMA, PRICE_CLOSE, 6);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML1M6", "|||||", 9, li_4, 120, 40);
   if(li_4==Red) M1RedCounter++;
   if(li_4==Tomato) M1TomatoCounter++;
   if(li_4==Lime) M1LimeCounter++;
   if(li_4==YellowGreen) M1YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M1, 25, 0, MODE_EMA, PRICE_CLOSE, 5);
   l_ima_16 = iMA(NULL, PERIOD_M1, 50, 0, MODE_EMA, PRICE_CLOSE, 5);
   l_ima_24 = iMA(NULL, PERIOD_M1, 5, 0, MODE_EMA, PRICE_CLOSE, 5);
   l_ima_32 = iMA(NULL, PERIOD_M1, 10, 0, MODE_LWMA, PRICE_CLOSE, 5);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML1M5", "|||||", 9, li_4, 135, 40);
   if(li_4==Red) M1RedCounter++;
   if(li_4==Tomato) M1TomatoCounter++;
   if(li_4==Lime) M1LimeCounter++;
   if(li_4==YellowGreen) M1YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M1, 25, 0, MODE_EMA, PRICE_CLOSE, 4);
   l_ima_16 = iMA(NULL, PERIOD_M1, 50, 0, MODE_EMA, PRICE_CLOSE, 4);
   l_ima_24 = iMA(NULL, PERIOD_M1, 5, 0, MODE_EMA, PRICE_CLOSE, 4);
   l_ima_32 = iMA(NULL, PERIOD_M1, 10, 0, MODE_LWMA, PRICE_CLOSE, 4);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML1M4", "|||||", 9, li_4, 150, 40);
   if(li_4==Red) M1RedCounter++;
   if(li_4==Tomato) M1TomatoCounter++;
   if(li_4==Lime) M1LimeCounter++;
   if(li_4==YellowGreen) M1YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M1, 25, 0, MODE_EMA, PRICE_CLOSE, 3);
   l_ima_16 = iMA(NULL, PERIOD_M1, 50, 0, MODE_EMA, PRICE_CLOSE, 3);
   l_ima_24 = iMA(NULL, PERIOD_M1, 5, 0, MODE_EMA, PRICE_CLOSE, 3);
   l_ima_32 = iMA(NULL, PERIOD_M1, 10, 0, MODE_LWMA, PRICE_CLOSE, 3);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML1M3", "|||||", 9, li_4, 165, 40);
   if(li_4==Red) M1RedCounter++;
   if(li_4==Tomato) M1TomatoCounter++;
   if(li_4==Lime) M1LimeCounter++;
   if(li_4==YellowGreen) M1YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M1, 25, 0, MODE_EMA, PRICE_CLOSE, 2);
   l_ima_16 = iMA(NULL, PERIOD_M1, 50, 0, MODE_EMA, PRICE_CLOSE, 2);
   l_ima_24 = iMA(NULL, PERIOD_M1, 5, 0, MODE_EMA, PRICE_CLOSE, 2);
   l_ima_32 = iMA(NULL, PERIOD_M1, 10, 0, MODE_LWMA, PRICE_CLOSE, 2);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML1M2", "|||||", 9, li_4, 180, 40);
   if(li_4==Red) M1RedCounter++;
   if(li_4==Tomato) M1TomatoCounter++;
   if(li_4==Lime) M1LimeCounter++;
   if(li_4==YellowGreen) M1YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M1, 25, 0, MODE_EMA, PRICE_CLOSE, 1);
   l_ima_16 = iMA(NULL, PERIOD_M1, 50, 0, MODE_EMA, PRICE_CLOSE, 1);
   l_ima_24 = iMA(NULL, PERIOD_M1, 5, 0, MODE_EMA, PRICE_CLOSE, 1);
   l_ima_32 = iMA(NULL, PERIOD_M1, 10, 0, MODE_LWMA, PRICE_CLOSE, 1);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML1M1", "|||||", 9, li_4, 195, 40);
   if(li_4==Red) M1RedCounter++;
   if(li_4==Tomato) M1TomatoCounter++;
   if(li_4==Lime) M1LimeCounter++;
   if(li_4==YellowGreen) M1YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M1, 25, 0, MODE_EMA, PRICE_CLOSE, 0);
   l_ima_16 = iMA(NULL, PERIOD_M1, 50, 0, MODE_EMA, PRICE_CLOSE, 0);
   l_ima_24 = iMA(NULL, PERIOD_M1, 5, 0, MODE_EMA, PRICE_CLOSE, 0);
   l_ima_32 = iMA(NULL, PERIOD_M1, 10, 0, MODE_LWMA, PRICE_CLOSE, 0);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML1M0", "|||||", 9, li_4, 210, 40);
   if(li_4==Red) M1RedCounter++;
   if(li_4==Tomato) M1TomatoCounter++;
   if(li_4==Lime) M1LimeCounter++;
   if(li_4==YellowGreen) M1YellowGreenCounter++;


   l_ima_8 = iMA(NULL, PERIOD_M5, 25, 0, MODE_EMA, PRICE_CLOSE, 9);
   l_ima_16 = iMA(NULL, PERIOD_M5, 50, 0, MODE_EMA, PRICE_CLOSE, 9);
   l_ima_24 = iMA(NULL, PERIOD_M5, 5, 0, MODE_EMA, PRICE_CLOSE, 9);
   l_ima_32 = iMA(NULL, PERIOD_M5, 10, 0, MODE_LWMA, PRICE_CLOSE, 9);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML5M9", "|||||", 9, li_4, 75, 55);
   if(li_4==Red) M5RedCounter++;
   if(li_4==Tomato) M5TomatoCounter++;
   if(li_4==Lime) M5LimeCounter++;
   if(li_4==YellowGreen) M5YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M5, 25, 0, MODE_EMA, PRICE_CLOSE, 8);
   l_ima_16 = iMA(NULL, PERIOD_M5, 50, 0, MODE_EMA, PRICE_CLOSE, 8);
   l_ima_24 = iMA(NULL, PERIOD_M5, 5, 0, MODE_EMA, PRICE_CLOSE, 8);
   l_ima_32 = iMA(NULL, PERIOD_M5, 10, 0, MODE_LWMA, PRICE_CLOSE, 8);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML5M8", "|||||", 9, li_4, 90, 55);
   if(li_4==Red) M5RedCounter++;
   if(li_4==Tomato) M5TomatoCounter++;
   if(li_4==Lime) M5LimeCounter++;
   if(li_4==YellowGreen) M5YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M5, 25, 0, MODE_EMA, PRICE_CLOSE, 7);
   l_ima_16 = iMA(NULL, PERIOD_M5, 50, 0, MODE_EMA, PRICE_CLOSE, 7);
   l_ima_24 = iMA(NULL, PERIOD_M5, 5, 0, MODE_EMA, PRICE_CLOSE, 7);
   l_ima_32 = iMA(NULL, PERIOD_M5, 10, 0, MODE_LWMA, PRICE_CLOSE, 7);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML5M7", "|||||", 9, li_4, 105, 55);
   if(li_4==Red) M5RedCounter++;
   if(li_4==Tomato) M5TomatoCounter++;
   if(li_4==Lime) M5LimeCounter++;
   if(li_4==YellowGreen) M5YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M5, 25, 0, MODE_EMA, PRICE_CLOSE, 6);
   l_ima_16 = iMA(NULL, PERIOD_M5, 50, 0, MODE_EMA, PRICE_CLOSE, 6);
   l_ima_24 = iMA(NULL, PERIOD_M5, 5, 0, MODE_EMA, PRICE_CLOSE, 6);
   l_ima_32 = iMA(NULL, PERIOD_M5, 10, 0, MODE_LWMA, PRICE_CLOSE, 6);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML5M6", "|||||", 9, li_4, 120, 55);
   if(li_4==Red) M5RedCounter++;
   if(li_4==Tomato) M5TomatoCounter++;
   if(li_4==Lime) M5LimeCounter++;
   if(li_4==YellowGreen) M5YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M5, 25, 0, MODE_EMA, PRICE_CLOSE, 5);
   l_ima_16 = iMA(NULL, PERIOD_M5, 50, 0, MODE_EMA, PRICE_CLOSE, 5);
   l_ima_24 = iMA(NULL, PERIOD_M5, 5, 0, MODE_EMA, PRICE_CLOSE, 5);
   l_ima_32 = iMA(NULL, PERIOD_M5, 10, 0, MODE_LWMA, PRICE_CLOSE, 5);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML5M5", "|||||", 9, li_4, 135, 55);
   if(li_4==Red) M5RedCounter++;
   if(li_4==Tomato) M5TomatoCounter++;
   if(li_4==Lime) M5LimeCounter++;
   if(li_4==YellowGreen) M5YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M5, 25, 0, MODE_EMA, PRICE_CLOSE, 4);
   l_ima_16 = iMA(NULL, PERIOD_M5, 50, 0, MODE_EMA, PRICE_CLOSE, 4);
   l_ima_24 = iMA(NULL, PERIOD_M5, 5, 0, MODE_EMA, PRICE_CLOSE, 4);
   l_ima_32 = iMA(NULL, PERIOD_M5, 10, 0, MODE_LWMA, PRICE_CLOSE, 4);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML5M4", "|||||", 9, li_4, 150, 55);
   if(li_4==Red) M5RedCounter++;
   if(li_4==Tomato) M5TomatoCounter++;
   if(li_4==Lime) M5LimeCounter++;
   if(li_4==YellowGreen) M5YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M5, 25, 0, MODE_EMA, PRICE_CLOSE, 3);
   l_ima_16 = iMA(NULL, PERIOD_M5, 50, 0, MODE_EMA, PRICE_CLOSE, 3);
   l_ima_24 = iMA(NULL, PERIOD_M5, 5, 0, MODE_EMA, PRICE_CLOSE, 3);
   l_ima_32 = iMA(NULL, PERIOD_M5, 10, 0, MODE_LWMA, PRICE_CLOSE, 3);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML5M3", "|||||", 9, li_4, 165, 55);
   if(li_4==Red) M5RedCounter++;
   if(li_4==Tomato) M5TomatoCounter++;
   if(li_4==Lime) M5LimeCounter++;
   if(li_4==YellowGreen) M5YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M5, 25, 0, MODE_EMA, PRICE_CLOSE, 2);
   l_ima_16 = iMA(NULL, PERIOD_M5, 50, 0, MODE_EMA, PRICE_CLOSE, 2);
   l_ima_24 = iMA(NULL, PERIOD_M5, 5, 0, MODE_EMA, PRICE_CLOSE, 2);
   l_ima_32 = iMA(NULL, PERIOD_M5, 10, 0, MODE_LWMA, PRICE_CLOSE, 2);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML5M2", "|||||", 9, li_4, 180, 55);
   if(li_4==Red) M5RedCounter++;
   if(li_4==Tomato) M5TomatoCounter++;
   if(li_4==Lime) M5LimeCounter++;
   if(li_4==YellowGreen) M5YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M5, 25, 0, MODE_EMA, PRICE_CLOSE, 1);
   l_ima_16 = iMA(NULL, PERIOD_M5, 50, 0, MODE_EMA, PRICE_CLOSE, 1);
   l_ima_24 = iMA(NULL, PERIOD_M5, 5, 0, MODE_EMA, PRICE_CLOSE, 1);
   l_ima_32 = iMA(NULL, PERIOD_M5, 10, 0, MODE_LWMA, PRICE_CLOSE, 1);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML5M1", "|||||", 9, li_4, 195, 55);
   if(li_4==Red) M5RedCounter++;
   if(li_4==Tomato) M5TomatoCounter++;
   if(li_4==Lime) M5LimeCounter++;
   if(li_4==YellowGreen) M5YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M5, 25, 0, MODE_EMA, PRICE_CLOSE, 0);
   l_ima_16 = iMA(NULL, PERIOD_M5, 50, 0, MODE_EMA, PRICE_CLOSE, 0);
   l_ima_24 = iMA(NULL, PERIOD_M5, 5, 0, MODE_EMA, PRICE_CLOSE, 0);
   l_ima_32 = iMA(NULL, PERIOD_M5, 10, 0, MODE_LWMA, PRICE_CLOSE, 0);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML5M0", "|||||", 9, li_4, 210, 55);
   if(li_4==Red) M5RedCounter++;
   if(li_4==Tomato) M5TomatoCounter++;
   if(li_4==Lime) M5LimeCounter++;
   if(li_4==YellowGreen) M5YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M15, 25, 0, MODE_EMA, PRICE_CLOSE, 9);
   l_ima_16 = iMA(NULL, PERIOD_M15, 50, 0, MODE_EMA, PRICE_CLOSE, 9);
   l_ima_24 = iMA(NULL, PERIOD_M15, 5, 0, MODE_EMA, PRICE_CLOSE, 9);
   l_ima_32 = iMA(NULL, PERIOD_M15, 10, 0, MODE_LWMA, PRICE_CLOSE, 9);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML15M9", "|||||", 9, li_4, 75, 70);
   if(li_4==Red) M15RedCounter++;
   if(li_4==Tomato) M15TomatoCounter++;
   if(li_4==Lime) M15LimeCounter++;
   if(li_4==YellowGreen) M15YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M15, 25, 0, MODE_EMA, PRICE_CLOSE, 8);
   l_ima_16 = iMA(NULL, PERIOD_M15, 50, 0, MODE_EMA, PRICE_CLOSE, 8);
   l_ima_24 = iMA(NULL, PERIOD_M15, 5, 0, MODE_EMA, PRICE_CLOSE, 8);
   l_ima_32 = iMA(NULL, PERIOD_M15, 10, 0, MODE_LWMA, PRICE_CLOSE, 8);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML15M8", "|||||", 9, li_4, 90, 70);
   if(li_4==Red) M15RedCounter++;
   if(li_4==Tomato) M15TomatoCounter++;
   if(li_4==Lime) M15LimeCounter++;
   if(li_4==YellowGreen) M15YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M15, 25, 0, MODE_EMA, PRICE_CLOSE, 7);
   l_ima_16 = iMA(NULL, PERIOD_M15, 50, 0, MODE_EMA, PRICE_CLOSE, 7);
   l_ima_24 = iMA(NULL, PERIOD_M15, 5, 0, MODE_EMA, PRICE_CLOSE, 7);
   l_ima_32 = iMA(NULL, PERIOD_M15, 10, 0, MODE_LWMA, PRICE_CLOSE, 7);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML15M7", "|||||", 9, li_4, 105, 70);
   if(li_4==Red) M15RedCounter++;
   if(li_4==Tomato) M15TomatoCounter++;
   if(li_4==Lime) M15LimeCounter++;
   if(li_4==YellowGreen) M15YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M15, 25, 0, MODE_EMA, PRICE_CLOSE, 6);
   l_ima_16 = iMA(NULL, PERIOD_M15, 50, 0, MODE_EMA, PRICE_CLOSE, 6);
   l_ima_24 = iMA(NULL, PERIOD_M15, 5, 0, MODE_EMA, PRICE_CLOSE, 6);
   l_ima_32 = iMA(NULL, PERIOD_M15, 10, 0, MODE_LWMA, PRICE_CLOSE, 6);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML15M6", "|||||", 9, li_4, 120, 70);
   if(li_4==Red) M15RedCounter++;
   if(li_4==Tomato) M15TomatoCounter++;
   if(li_4==Lime) M15LimeCounter++;
   if(li_4==YellowGreen) M15YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M15, 25, 0, MODE_EMA, PRICE_CLOSE, 5);
   l_ima_16 = iMA(NULL, PERIOD_M15, 50, 0, MODE_EMA, PRICE_CLOSE, 5);
   l_ima_24 = iMA(NULL, PERIOD_M15, 5, 0, MODE_EMA, PRICE_CLOSE, 5);
   l_ima_32 = iMA(NULL, PERIOD_M15, 10, 0, MODE_LWMA, PRICE_CLOSE, 5);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML15M5", "|||||", 9, li_4, 135, 70);
   if(li_4==Red) M15RedCounter++;
   if(li_4==Tomato) M15TomatoCounter++;
   if(li_4==Lime) M15LimeCounter++;
   if(li_4==YellowGreen) M15YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M15, 25, 0, MODE_EMA, PRICE_CLOSE, 4);
   l_ima_16 = iMA(NULL, PERIOD_M15, 50, 0, MODE_EMA, PRICE_CLOSE, 4);
   l_ima_24 = iMA(NULL, PERIOD_M15, 5, 0, MODE_EMA, PRICE_CLOSE, 4);
   l_ima_32 = iMA(NULL, PERIOD_M15, 10, 0, MODE_LWMA, PRICE_CLOSE, 4);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML15M4", "|||||", 9, li_4, 150, 70);
   if(li_4==Red) M15RedCounter++;
   if(li_4==Tomato) M15TomatoCounter++;
   if(li_4==Lime) M15LimeCounter++;
   if(li_4==YellowGreen) M15YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M15, 25, 0, MODE_EMA, PRICE_CLOSE, 3);
   l_ima_16 = iMA(NULL, PERIOD_M15, 50, 0, MODE_EMA, PRICE_CLOSE, 3);
   l_ima_24 = iMA(NULL, PERIOD_M15, 5, 0, MODE_EMA, PRICE_CLOSE, 3);
   l_ima_32 = iMA(NULL, PERIOD_M15, 10, 0, MODE_LWMA, PRICE_CLOSE, 3);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML15M3", "|||||", 9, li_4, 165, 70);
   if(li_4==Red) M15RedCounter++;
   if(li_4==Tomato) M15TomatoCounter++;
   if(li_4==Lime) M15LimeCounter++;
   if(li_4==YellowGreen) M15YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M15, 25, 0, MODE_EMA, PRICE_CLOSE, 2);
   l_ima_16 = iMA(NULL, PERIOD_M15, 50, 0, MODE_EMA, PRICE_CLOSE, 2);
   l_ima_24 = iMA(NULL, PERIOD_M15, 5, 0, MODE_EMA, PRICE_CLOSE, 2);
   l_ima_32 = iMA(NULL, PERIOD_M15, 10, 0, MODE_LWMA, PRICE_CLOSE, 2);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML15M2", "|||||", 9, li_4, 180, 70);
   if(li_4==Red) M15RedCounter++;
   if(li_4==Tomato) M15TomatoCounter++;
   if(li_4==Lime) M15LimeCounter++;
   if(li_4==YellowGreen) M15YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M15, 25, 0, MODE_EMA, PRICE_CLOSE, 1);
   l_ima_16 = iMA(NULL, PERIOD_M15, 50, 0, MODE_EMA, PRICE_CLOSE, 1);
   l_ima_24 = iMA(NULL, PERIOD_M15, 5, 0, MODE_EMA, PRICE_CLOSE, 1);
   l_ima_32 = iMA(NULL, PERIOD_M15, 10, 0, MODE_LWMA, PRICE_CLOSE, 1);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML15M1", "|||||", 9, li_4, 195, 70);
   if(li_4==Red) M15RedCounter++;
   if(li_4==Tomato) M15TomatoCounter++;
   if(li_4==Lime) M15LimeCounter++;
   if(li_4==YellowGreen) M15YellowGreenCounter++;

   l_ima_8 = iMA(NULL, PERIOD_M15, 25, 0, MODE_EMA, PRICE_CLOSE, 0);
   l_ima_16 = iMA(NULL, PERIOD_M15, 50, 0, MODE_EMA, PRICE_CLOSE, 0);
   l_ima_24 = iMA(NULL, PERIOD_M15, 5, 0, MODE_EMA, PRICE_CLOSE, 0);
   l_ima_32 = iMA(NULL, PERIOD_M15, 10, 0, MODE_LWMA, PRICE_CLOSE, 0);
   if (l_ima_8 > l_ima_16) {
      li_4 = YellowGreen;
      if (l_ima_24 > l_ima_8 && l_ima_32 >= l_ima_8)
         if (l_ima_24 > l_ima_32) li_4 = Lime;
      if (l_ima_24 < l_ima_16) li_4 = Tomato;
      if (l_ima_24 >= l_ima_16 && l_ima_24 <= l_ima_8) li_4 = White;
   }
   if (l_ima_8 < l_ima_16) {
      li_4 = Tomato;
      if (l_ima_24 < l_ima_8 && l_ima_32 <= l_ima_8)
         if (l_ima_24 < l_ima_32) li_4 = Red;
      if (l_ima_24 > l_ima_16) li_4 = YellowGreen;
      if (l_ima_24 <= l_ima_16 && l_ima_24 >= l_ima_8) li_4 = White;
   }
   if (l_ima_8 == l_ima_16) {
      if (l_ima_24 < l_ima_32) li_4 = Tomato;
      if (l_ima_24 > l_ima_32) li_4 = YellowGreen;
   }
   drawPSR("DML15M0", "|||||", 9, li_4, 210, 70);
   if(li_4==Red) M15RedCounter++;
   if(li_4==Tomato) M15TomatoCounter++;
   if(li_4==Lime) M15LimeCounter++;
   if(li_4==YellowGreen) M15YellowGreenCounter++;

   if (Period() == PERIOD_M1) {
      drawPSR("DSMSG", "DIRECTION", 10, Yellow, 15, 90);
      drawPSR("D30D", "  30mnt :", 9, White, 20, 110);
      drawPSR("D60D", "  60mnt :", 9, White, 20, 125);
      drawPSR("D120D", "120mnt :", 9, White, 20, 140);
      drawPSR("D30M4", "|||||", 9, Silver, 75, 110);
      drawPSR("D30M3", "|||||", 9, Silver, 90, 110);
      drawPSR("D30M2", "|||||", 9, Silver, 105, 110);
      drawPSR("D30M1", "|||||", 9, Silver, 120, 110);
      drawPSR("D30N", "||", 9, Yellow, 135, 110);
      drawPSR("D30P1", "|||||", 9, Silver, 141, 110);
      drawPSR("D30P2", "|||||", 9, Silver, 156, 110);
      drawPSR("D30P3", "|||||", 9, Silver, 171, 110);
      drawPSR("D30P4", "|||||", 9, Silver, 186, 110);
      ld_40 = (Close[1] - Close[31]) / Point;
      if (ld_40 > 0.0) {M30LimeCounter++; drawPSR("D30P1", "|||||", 9, Lime, 141, 110);}
      if (ld_40 > 50.0) {M30LimeCounter++; drawPSR("D30P2", "|||||", 9, Lime, 156, 110);}
      if (ld_40 > 100.0) {M30LimeCounter++; drawPSR("D30P3", "|||||", 9, Lime, 171, 110);}
      if (ld_40 > 150.0) {M30LimeCounter++; drawPSR("D30P4", "|||||", 9, Lime, 186, 110);}
      if (ld_40 < 0.0) {M30RedCounter++; drawPSR("D30M1", "|||||", 9, Red, 120, 110);}
      if (ld_40 < -50.0) {M30RedCounter++; drawPSR("D30M2", "|||||", 9, Red, 105, 110);}
      if (ld_40 < -100.0) {M30RedCounter++; drawPSR("D30M3", "|||||", 9, Red, 90, 110);}
      if (ld_40 < -150.0) {M30RedCounter++; drawPSR("D30M4", "|||||", 9, Red, 75, 110);}
      drawPSR("D60M4", "|||||", 9, Silver, 75, 125);
      drawPSR("D60M3", "|||||", 9, Silver, 90, 125);
      drawPSR("D60M2", "|||||", 9, Silver, 105, 125);
      drawPSR("D60M1", "|||||", 9, Silver, 120, 125);
      drawPSR("D60N", "||", 9, Yellow, 135, 125);
      drawPSR("D60P1", "|||||", 9, Silver, 141, 125);
      drawPSR("D60P2", "|||||", 9, Silver, 156, 125);
      drawPSR("D60P3", "|||||", 9, Silver, 171, 125);
      drawPSR("D60P4", "|||||", 9, Silver, 186, 125);
      ld_40 = (Close[1] - Close[61]) / Point;
      if (ld_40 > 0.0) {H1LimeCounter++; drawPSR("D60P1", "|||||", 9, Lime, 141, 125);}
      if (ld_40 > 50.0) {H1LimeCounter++; drawPSR("D60P2", "|||||", 9, Lime, 156, 125);}
      if (ld_40 > 100.0) {H1LimeCounter++; drawPSR("D60P3", "|||||", 9, Lime, 171, 125);}
      if (ld_40 > 150.0) {H1LimeCounter++; drawPSR("D60P4", "|||||", 9, Lime, 186, 125);}
      if (ld_40 < 0.0) {H1RedCounter++; drawPSR("D60M1", "|||||", 9, Red, 120, 125);}
      if (ld_40 < -50.0) {H1RedCounter++; drawPSR("D60M2", "|||||", 9, Red, 105, 125);}
      if (ld_40 < -100.0) {H1RedCounter++; drawPSR("D60M3", "|||||", 9, Red, 90, 125);}
      if (ld_40 < -150.0) {H1RedCounter++; drawPSR("D60M4", "|||||", 9, Red, 75, 125);}
      drawPSR("D120M4", "|||||", 9, Silver, 75, 140);
      drawPSR("D120M3", "|||||", 9, Silver, 90, 140);
      drawPSR("D120M2", "|||||", 9, Silver, 105, 140);
      drawPSR("D120M1", "|||||", 9, Silver, 120, 140);
      drawPSR("D120N", "||", 9, Yellow, 135, 140);
      drawPSR("D120P1", "|||||", 9, Silver, 141, 140);
      drawPSR("D120P2", "|||||", 9, Silver, 156, 140);
      drawPSR("D120P3", "|||||", 9, Silver, 171, 140);
      drawPSR("D120P4", "|||||", 9, Silver, 186, 140);
      ld_40 = (Close[1] - Close[121]) / Point;
      if (ld_40 > 0.0) {H2LimeCounter++; drawPSR("D120P1", "|||||", 9, Lime, 141, 140);}
      if (ld_40 > 50.0) {H2LimeCounter++; drawPSR("D120P2", "|||||", 9, Lime, 156, 140);}
      if (ld_40 > 100.0) {H2LimeCounter++; drawPSR("D120P3", "|||||", 9, Lime, 171, 140);}
      if (ld_40 > 150.0) {H2LimeCounter++; drawPSR("D120P4", "|||||", 9, Lime, 186, 140);}
      if (ld_40 < 0.0) {H2RedCounter++; drawPSR("D120M1", "|||||", 9, Red, 120, 140);}
      if (ld_40 < -50.0) {H2RedCounter++; drawPSR("D120M2", "|||||", 9, Red, 105, 140);}
      if (ld_40 < -100.0) {H2RedCounter++; drawPSR("D120M3", "|||||", 9, Red, 90, 140);}
      if (ld_40 < -150.0) {H2RedCounter++; drawPSR("D120M4", "|||||", 9, Red, 75, 140);}
   }
   ArrayCopyRates(lda_48, Symbol(), PERIOD_D1);
   if (DayOfWeek() == 1) {
      if (TimeDayOfWeek(iTime(Symbol(), PERIOD_D1, 1)) == 5) {
         ld_52 = lda_48[1][4];
         ld_60 = lda_48[1][3];
         ld_68 = lda_48[1][2];
      } else {
         for (int li_76 = 5; li_76 >= 0; li_76--) {
            if (TimeDayOfWeek(iTime(Symbol(), PERIOD_D1, li_76)) == 5) {
               ld_52 = lda_48[li_76][4];
               ld_60 = lda_48[li_76][3];
               ld_68 = lda_48[li_76][2];
            }
         }
      }
   } else {
      ld_52 = lda_48[1][4];
      ld_60 = lda_48[1][3];
      ld_68 = lda_48[1][2];
   }
   double ld_80 = ld_60 - ld_68;
   double ld_88 = (ld_60 + ld_68 + ld_52) / 3.0;
   double ld_96 = 2.0 * ld_88 - ld_68;
   double ld_104 = 2.0 * ld_88 - ld_60;
   double ld_112 = ld_88 + ld_96 - ld_104;
   double ld_120 = ld_88 - ld_96 + ld_104;
   double R3 = ld_88 + ld_112 - ld_104;
   double S3 = ld_88 - ld_112 + ld_104;
   double ld_144 = ld_88 + (ld_96 - ld_88) / 2.0;
   double ld_152 = ld_88 - (ld_88 - ld_104) / 2.0;
   double ld_160 = ld_96 + (ld_112 - ld_96) / 2.0;
   double ld_168 = ld_104 - (ld_104 - ld_120) / 2.0;
   double ld_176 = ld_112 + (R3 - ld_112) / 2.0;
   double ld_184 = ld_120 - (ld_120 - S3) / 2.0;
   drawLine(R3, "R3", Lime, 0);
   drawLabel("Resistance 3", R3, Lime);
   drawLine(ld_176, "R23", Violet, 0);
   drawLabel("R2-R3", ld_176, Violet);
   drawLine(ld_112, "R2", Lime, 0);
   drawLabel("Resistance 2", ld_112, Lime);
   drawLine(ld_160, "R12", Violet, 0);
   drawLabel("R1-R2", ld_160, Violet);
   drawLine(ld_96, "R1", Lime, 0);
   drawLabel("Resistance 1", ld_96, Lime);
   drawLine(ld_144, "R01", Violet, 0);
   drawLabel("P-R1", ld_144, Violet);
   drawLine(ld_88, "PIVOT", Aqua, 2);
   drawLabel("Pivot level", ld_88, Blue);
   drawLine(ld_152, "S01", Violet, 0);
   drawLabel("P-S1", ld_152, Violet);
   drawLine(ld_104, "S1", FireBrick, 0);
   drawLabel("Support 1", ld_104, FireBrick);
   drawLine(ld_168, "S12", Violet, 0);
   drawLabel("S1-S2", ld_168, Violet);
   drawLine(ld_120, "S2", FireBrick, 0);
   drawLabel("Support 2", ld_120, FireBrick);
   drawLine(ld_184, "S23", Violet, 0);
   drawLabel("S2-S3", ld_184, Violet);
   drawLine(S3, "S3", FireBrick, 0);
   drawLabel("Support 3", S3, FireBrick);
   if (Period() == PERIOD_M1) {
      ObjectCreate("DLEVEL", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("DLEVEL", "PSR Level", 10, "Arial Bold", Yellow);
      ObjectSet("DLEVEL", OBJPROP_XDISTANCE, 15);
      ObjectSet("DLEVEL", OBJPROP_YDISTANCE, 155);
      ls_192 = R3;
      ls_192 = "R3   : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DR3", ls_192, 9, Lime, 23, 170);
      ls_192 = ld_176;
      ls_192 = "R23 : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DR23", ls_192, 9, Violet, 23, 180);
      ls_192 = ld_112;
      ls_192 = "R2   : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DR2", ls_192, 9, Lime, 23, 190);
      ls_192 = ld_160;
      ls_192 = "R12 : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DR12", ls_192, 9, Violet, 23, 200);
      ls_192 = ld_96;
      ls_192 = "R1   : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DR1", ls_192, 9, Lime, 23, 210);
      ls_192 = ld_144;
      ls_192 = "R01 : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DR01", ls_192, 9, Violet, 23, 220);
      ls_192 = ld_88;
      ls_192 = "PIV : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DP", ls_192, 9, SkyBlue, 23, 230);
      ls_192 = ld_152;
      ls_192 = "S01 : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DS01", ls_192, 9, Violet, 23, 240);
      ls_192 = ld_104;
      ls_192 = "S1   : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DS1", ls_192, 9, FireBrick, 23, 250);
      ls_192 = ld_168;
      ls_192 = "S12 : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DS12", ls_192, 9, Violet, 23, 260);
      ls_192 = ld_120;
      ls_192 = "S2   : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DS2", ls_192, 9, FireBrick, 23, 270);
      ls_192 = ld_184;
      ls_192 = "S23 : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DS23", ls_192, 9, Violet, 23, 280);
      ls_192 = S3;
      ls_192 = "S3   : " + StringSubstr(ls_192, 0, 6);
      drawPSR("DS3", ls_192, 9, FireBrick, 23, 290);
   }
   DoAlert(S3,R3);   
   PrevBid=Bid;
   return (0);
}

string PeriodToStr(int a){
   if(a==PERIOD_M1) return("M1");
   if(a==PERIOD_M5) return("M5");
   if(a==PERIOD_M15) return("M15");
   if(a==PERIOD_M30) return("M30");
   if(a==PERIOD_H1) return("H1");
   if(a==PERIOD_H4) return("H4");
   if(a==PERIOD_D1) return("D1");
   if(a==PERIOD_W1) return("W1");
   if(a==PERIOD_MN1) return("MN1");
   return("");
}

void DoAlert(double S3, double R3)
{
   string text="";
   
   if(AlertOnAllTFSignalSinc){
      if(ALLBARLastAlertTime==Time[0]) return;
      int TotalRed=M1RedCounter+M5RedCounter+M15RedCounter+M30RedCounter+H1RedCounter+H2RedCounter;
      int TotalTomato=M1TomatoCounter+M5TomatoCounter+M15TomatoCounter;
      int TotalLime=M1LimeCounter+M5LimeCounter+M15LimeCounter+M30LimeCounter+H1LimeCounter+H2LimeCounter;
      int TotalYellowGreen=M1YellowGreenCounter+M5YellowGreenCounter+M15YellowGreenCounter;
      if(TotalRed>=MinRedCount && TotalLime==0 && TotalYellowGreen==0){
         text=Symbol()+" "+PeriodToStr(Period())+" ALL TIMEFRAME Color is RED "+TimeToStr(Time[0],TIME_DATE|TIME_MINUTES);
         Alert(text);
         if(SaveScreenshot) WindowScreenShot("shots\\"+ScreenshotPrefix+"_RED_"+PeriodToStr(Period())+"_"+TimeToStr(Time[0],TIME_DATE)+" "+Hour()+"_"+Minute()+".gif",640,480);
         if(SendEmail) SendMail("Ammar Data Info Alert",text);
         ALLBARLastAlertTime=Time[0];
      }
      if(TotalLime>=MinLimeCount && TotalRed==0 && TotalTomato==0){
         text=Symbol()+" "+PeriodToStr(Period())+" ALL TIMEFRAME Color is LIME "+TimeToStr(Time[0],TIME_DATE|TIME_MINUTES);
         Alert(text);
         if(SaveScreenshot) WindowScreenShot("shots\\"+ScreenshotPrefix+"_LIME_"+PeriodToStr(Period())+"_"+TimeToStr(Time[0],TIME_DATE)+" "+Hour()+"_"+Minute()+".gif",640,480);
         if(SendEmail) SendMail("Ammar Data Info Alert",text);
         ALLBARLastAlertTime=Time[0];
      }
   }
   if(AlertR3){
      if(R3LastAlertTime==Time[0]) return;
      if(PrevBid<R3 && Bid>=R3){
         text=Symbol()+" "+PeriodToStr(Period())+" Price Breach R3 "+TimeToStr(Time[0],TIME_DATE|TIME_MINUTES);
         Alert(text);
         if(SaveScreenshot) WindowScreenShot("shots\\"+ScreenshotPrefix+"_R3_"+PeriodToStr(Period())+"_"+TimeToStr(Time[0],TIME_DATE)+" "+Hour()+"_"+Minute()+".gif",640,480);
         if(SendEmail) SendMail("Ammar Data Info Alert",text);
         R3LastAlertTime=Time[0];
      }
   }
   if(AlertS3){
      if(S3LastAlertTime==Time[0]) return;
      if(PrevBid>S3 && Bid<=S3){
         text=Symbol()+" "+PeriodToStr(Period())+" Price Breach S3 "+TimeToStr(Time[0],TIME_DATE|TIME_MINUTES);
         Alert(text);
         if(SaveScreenshot) WindowScreenShot("shots\\"+ScreenshotPrefix+"_S3_"+PeriodToStr(Period())+"_"+TimeToStr(Time[0],TIME_DATE)+" "+Hour()+"_"+Minute()+".gif",640,480);
         if(SendEmail) SendMail("Ammar Data Info Alert",text);
         S3LastAlertTime=Time[0];
      }
   }
}

void drawLabel(string a_name_0, double a_price_8, color a_color_16) {
   if (ObjectFind(a_name_0) != 0) {
      ObjectCreate(a_name_0, OBJ_TEXT, 0, Time[15], a_price_8);
      ObjectSetText(a_name_0, a_name_0, 10, "Arial", CLR_NONE);
      ObjectSet(a_name_0, OBJPROP_COLOR, a_color_16);
      return;
   }
   ObjectMove(a_name_0, 0, Time[15], a_price_8);
}

void drawLine(double a_price_0, string a_name_8, color a_color_16, int ai_20) {
   if (ObjectFind(a_name_8) != 0) {
      ObjectCreate(a_name_8, OBJ_HLINE, 0, Time[0], a_price_0, Time[0], a_price_0);
      if (ai_20 == 1) ObjectSet(a_name_8, OBJPROP_STYLE, STYLE_SOLID);
      else ObjectSet(a_name_8, OBJPROP_STYLE, STYLE_DOT);
      ObjectSet(a_name_8, OBJPROP_COLOR, a_color_16);
      ObjectSet(a_name_8, OBJPROP_WIDTH, 1);
      return;
   }
   ObjectDelete(a_name_8);
   ObjectCreate(a_name_8, OBJ_HLINE, 0, Time[0], a_price_0, Time[0], a_price_0);
   if (ai_20 == 1) ObjectSet(a_name_8, OBJPROP_STYLE, STYLE_SOLID);
   else ObjectSet(a_name_8, OBJPROP_STYLE, STYLE_DOT);
   ObjectSet(a_name_8, OBJPROP_COLOR, a_color_16);
   ObjectSet(a_name_8, OBJPROP_WIDTH, 1);
}

void drawPSR(string a_name_0, string a_text_8, int a_fontsize_16, color a_color_20, int a_x_24, int a_y_28) {
   ObjectCreate(a_name_0, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(a_name_0, a_text_8, a_fontsize_16, "Arial Bold", a_color_20);
   ObjectSet(a_name_0, OBJPROP_XDISTANCE, a_x_24);
   ObjectSet(a_name_0, OBJPROP_YDISTANCE, a_y_28);
}